/* *************************************************************************
                          cameraperspective.cpp  -  description
                             -------------------
    begin                : Wed Oct 16 2002       
    copyright            : (C) 2002 by Micha Riser
    email                : mriser@gmx.net
 ************************************************************************* */

/* *************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ************************************************************************* */

#include "cameraperspective.h"
#include "scene.h"
#include "cameraray.h"

Colour5 CameraPerspective::evaluateAt(const Vector3& p) const {

    if (insides == 0) {
        insides = new InsideList();
        scene->object.listInside(location,*insides);
    }
    Vector3 rdir = direction;
    rdir.add(right.scaled(p.a[0]-.5));
    rdir.add(up.scaled(p.a[1]-.5));
    CameraRay shoot(location,rdir,scene,new InsideList(*insides));
    return scene->intersect(shoot);
  
}

